

  #define Version "190521"

//envoi d'un message jusqu'  32 car affich sur les 2 Lignes
// test avec PCF8754 + LCD1602 classic  2x16 cars

 //ac:pinout
  
// rajout Beeper  sur RA3

#define Project "18F46K22_LCD_1602_2x16_I2C_PCF8754_2019.mcppi"
#define Source "_18F46k22_LCD_1602_2x16_I2C1_HW"


//  LCD 1602  2x16 car
// Pin 1    Gnd 0V
// Pin 2    +VSS=5V
// Pin 3    R=2,7K to Grnd (or potentiometer)
// Pin 4    RS    H=Data    L=Cde              D0
// Pin 5    R/W   L=Data Write -- Gnd 0V
// Pin 6    Enable   H-> L                     D1
// Pin 7-8-9-10
//  Pin 11  Data     D4
//  Pin 12  Data     D5
//  Pin 13  Data     D6
//  Pin 14  Data     D7
//  Pin 15  Anode Led retro eclairage
//  Pin 16  Katode retro...

// #define With_TMR1
#define OSCILLATEUR_INTERNE
#define  TEST_FOSC    //  tester au moins 1 fois...

#define With_Gros_LCD_2x16_PCF8754
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS

 #define PROCESSOR 18F46k22
 #define POWER_SUPPLY_5

 #ifdef OSCILLATEUR_INTERNE
 #define FOSC 16.0      // MHz
 #define BAUD 19200     // UART1
 //P18F46K22_FOSCinterne_No_PLL.cfgsch
 //18F46K22_FOSC_Interne_16Mhz.cfgsch
 #endif

#include "built_in.h"     // for  Hi  Lo ..etc
#include "../common/String_routines.h"



//avec gros LCD 2x16 cars
//  http://www.miniinthebox.com/fr/iic-i2c-adaptateur-d-interface-carte-lcd1602-et-accessoires_p3206322.html
//  IIC / i2c / adaptateur d'interface carte LCD1602 et accessoires #03206322
//

#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BELL 7
#define BACK 8
#define Separator 0x20   // space
#define uchar unsigned char
#define uint    unsigned int
#define boolean  bit
#define ushort   unsigned short

 /*
 Exemple pour le symbole Omega ralisation manuel:
byte newChar[8] = {
.....       00000       B00000,
.XXX.       01110       B01110,
X...X       10001       B10001,
X...X  --\  10001  --\  B10001,
.X.X.  --/  01010  --/  B01010,
.X.X.       01010       B01010,
XX.XX       11011       B11011,
.....       00000       B00000 };
*/



 // 2016
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01



// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08

#define LCD_LINE1 0x80 // 0x00 + bit D7=1
#define LCD_LINE2 0xC0 // 0x40 + bit D7=1
#define LCD_LINE3 0x94 // 0x14 + bit D7=1
#define LCD_LINE4 0xD4 // 0x54 + bit D7=1

const Ligne[4]={0x80,0xC0,0x94,0xD4};

sbit LedA  at LATA.B4;
sbit LedA_Direction  at TRISA4_bit;

unsigned char CRam1[64];
char TEXTE[128];
char *txt;
char IntValue[12];

int Etat;
static unsigned char addr;
static unsigned char LCD_ADR;

unsigned int Flag_Timer0;
unsigned int Cpt0;
unsigned int Flag_Timer1;
unsigned int Cpt1;

unsigned int i,j,k,l;                              // Loop variable
unsigned int M;
unsigned int EA0,EA1,EA2 ;   // 3 mesures ANA => 3 consignes R,G,B
unsigned int Table_EA[8];
unsigned int NbVal;
int Dummy;
float f1;

// pour test FOSC
unsigned long Freq;

#define MAXLEN1 128
unsigned char buffer1[MAXLEN1];
unsigned int Index1=0;
unsigned int i1=0;
unsigned int UART1_DataReady=0;
unsigned char c1=0;
unsigned char *p;


unsigned char  check_device(unsigned char dev_address);


unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_init_2x16(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_puts(char *s);
void LCD_putsRom(code char *s);
void LCD_display_date_Time(void);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);

void UART1_Write_CText(const char *txt1);
void CRLF1(void);

void Interrupts() iv 0x0008 ics ICS_AUTO
{
//UART1
  if((RC1IF_bit==1) && (RC1IE_bit==1))
  {
     c1 = RCREG1;
       //UART_Write('*');
     if(OERR1_bit)
      {
       CREN1_bit = 0;
       CREN1_bit = 1;
      }
     if(FERR1_bit)
     {
       c1 = RCREG1;
       c1 = 0;
     }

     if (c1==13)
      {
      UART1_DataReady=1;
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
       buffer1[i1]=c1;
        Index1=i1;
        i1++;
      }
     if (i1 >=MAXLEN1)
      {
          UART1_DataReady=2;
          RC1IE_bit=0 ;    //interdit IT Reception UART
          buffer1[i1]=0;
          Index1=i1;
          i1=0;
          c1=0;
      }
   }
   #ifdef With_TMR0
  //   ====  IT Timer0  =============
  if((TMR0IE_bit==1) && (TMR0IF_bit==1))
  {
    #ifdef DEBUGGING
    TXREG1='*';
    #endif
    Cpt0++;
    if(Cpt0>NB_IT_TMR0)
     {
       Flag_Timer0=1;
       TMR0IE_bit=0;  // interdit interrupt
       Cpt0=0;
       TMR0ON_bit=0; // stop timer
     }
      // 1000msec at 48MHz et prescaler=256
      TMR0H= 0x48; // hi 18661;
      TMR0L =0xE5 ; // Lo 18661;
      TMR0IF_bit=0; // Raz Flag
  }
  #endif
   #ifdef With_TMR1
  //   ====  IT Timer1  =============
  if((TMR1IE_bit==1) && (TMR1IF_bit==1))
  {
      // TMR1IE_bit=0;  // interdit interrupt
      Cpt1++;
      if (Cpt1>100)
      {
          TXREG1='$';  // pour debugging sur UART1
          Cpt1=0;
      }
      Flag_Timer1=1;
      TMR1ON_bit=0; // stop timer
       // 25mS  at 48MHz  28036 => 6D84  prescaler =8
       TMR1H= 0x6D; // hi 28036;
       TMR1L =0x84 ; // Lo 28036;
      TMR1IF_bit=0; // Raz Flag
  }
  #endif
}

 //========== LCD 2x16 sur bus I2C ================================

void Erase_Line(int L)
{
switch(L)
 {
 case 1:
  {
   LCD_putcmd(LCD_LINE1,1);
   LCD_Write_CText("                    ");
   LCD_putcmd(LCD_LINE1,1);
   break;
  }
  case 2:
  {
   LCD_putcmd(LCD_LINE2,1);
   LCD_Write_CText("                    ");
   LCD_putcmd(LCD_LINE2,1);
    break;
  }
  /*
  case 3:
  {
   LCD_putcmd(LCD_LINE3,1);
   LCD_Write_CText("                    ");
   LCD_putcmd(LCD_LINE3,1);
    break;
  }
  case 4:
  {
   LCD_putcmd(LCD_LINE4,1);
   LCD_Write_CText("                    ");
   LCD_putcmd(LCD_LINE4,1);
    break;
  }
  */
  
 }
}


 unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value)
{
 unsigned char S,dummy;
 I2C1_Start();
 S = I2C1_Wr( Adr );
 if(S == -1)        //check if bus collision happened
 {
   dummy = SSP1BUF;        //upon bus collision detection clear the buffer,
   SSPCON1.WCOL=0;    // clear the bus collision Etat bit
 }
 S = I2C1_Wr(value);
 I2C1_Stop();
 return(S);
}
/*
  PCA8574 I2C LCD Routine
  LCD Data PCA8574: P7,P6,P5,P4
  LCD Control: P3: Back Light, P2: E-Enable, P1:RW, P0: RS
*/
 

void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
  unsigned char lcddata;
 // UART1_Write('-');
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)| LCD_BL;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(50);
 // UART1_Write('a');
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(50);      // Delay 1us for 16 MHz Internal Clock
  //UART1_Write('b');
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype==1) {
    // Put the Lower 4 bits data
    lcddata = ((d << 4) & 0xF0)|LCD_BL;
    Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
    Delay_us(10);    // Delay 2us for 16 MHz Internal Clock
  //  UART1_Write('c');
    // Write Enable Pulse E: Hi -> Lo
    Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
    Delay_ms(5);    // Delay 1us for 16 MHz Internal Clock
  //  UART1_Write('d');
  }
}

void LCD_putch(unsigned char d)
{
  unsigned char lcddata;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(10);      // Delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
  lcddata = ((d << 4) & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(addr,lcddata & ~LCD_EN);
  Delay_us(25);      // Delay 1us for 16 MHz Internal Clock
}

void LCD_init_2x16(void)
{ UART1_Write('0');
  // Wait for more than 15 ms after VCC rises to 4.5 V
  Delay_ms(100);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  UART1_Write('1');
  // Wait for more than 4.1 ms
  Delay_ms(25);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  UART1_Write('2');
  // Wait for more than 100 us
  Delay_ms(25);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  UART1_Write('3');
    Delay_ms(25);
  // Function set: Set interface to be 4 bits long (only 1 cycle write).
  LCD_putcmd(0x25,0);
  UART1_Write('4');
    Delay_ms(20);
  // Function set: DL=0;Interface is 4 bits, N=1; 2 Lines, F=0; 5x8 dots font)
  LCD_putcmd(0x28,1);
  UART1_Write('5');
    Delay_ms(20);
  // Display Off: D=0; Display off, C=0; Cursor Off, B=0; Blinking Off
  LCD_putcmd(0x08,1);
  UART1_Write('6');
    Delay_ms(20);
  // Display Clear
  LCD_putcmd(LCD_CLEAR,1);
  UART1_Write('7');
    Delay_ms(100);
  // Entry Mode Set: I/D=1; Increament, S=0; No shift
  LCD_putcmd(0x06,1);
  UART1_Write('8');
    Delay_ms(20);
  // Display On, Cursor Off
  LCD_putcmd(0x0C,1);
  UART1_Write('9');
    Delay_ms(20);
    CRLF1();
}

void LCD_putsRom(const code char *s)
{int i=0;
  while((*s != 0)&& (i<20))
  {
    LCD_putch(*s);
    s++;i++;
  }
}

void LCD_puts( char *s)
{int i=0;
  while((*(s+i) != 0)&& (i<20))
  {
    LCD_putch(*(s+i));
    i++;
  }
}

void LCD_Write_CText(const char *txt1)
{
   while (*txt1)
   LCD_putch(*txt1++);
 }

void LCDHandler(char c) {
  LCD_putch(c);
}


//==============================


unsigned char  check_device(unsigned char dev_address)
{

unsigned char OK;
OK=0;
UART1_Write_CText("Device at adresse : ");
ByteToStr(dev_address,CRam1);
UART1_Write_Text(CRam1);
I2C1_Start();
if(I2C1_Wr(dev_address)!=0 )
 {
  UART1_Write_CText(" is not found");
 }
 else
 {
  UART1_Write_CText(" found OK");
  OK=1;
  }
I2C1_Stop();
 CRLF1();
 return OK;
}



void Init_Timer1(void)
{
 //  T1CON.RD16=1 ;  // Mode 16 bits
// T1RUN_bit=0 ;  //  Device clock is NOT derived from Timer1 oscillator
 T1CKPS1_bit=1;  // prescaler =1/8
 T1CKPS0_bit=1;
 T1OSCEN_bit=0; // Secondary Oscillator Disabled
 T1CON.SYNC=0;   // Synchro extern clock input with Fosc  (ignore)
 T1CON.TMR1CS1=0;  // clock source= Fosc/4
 T1CON.TMR1CS0=0;
 T1CON.TMR1ON=0;   // Stop timer1

// 25mS  at 48MHz  28036 => 6D84  prescaler =8
  TMR1H= 0x6D; // hi 28036;
  TMR1L =0x84 ; // Lo 28036;
  //----
  IPR1.TMR1IP=1;      // set hihh priority for Timer1
  RCON.IPEN = 1;      // Enable High interrupt priority model.

  TMR1IF_bit=0;      // raz flag interrupt
  INTCON.PEIE = 0;    // enable interupt Peripheriques
  T1CON.TMR1ON=0;     // desactive Timer1
  PIE1.TMR1IE=0;      // Disable Interrupt Timer1
  GIE_bit = 0;     // Desactive global interrupt
}

void UART1_Write_CText(const char *txt1)
{
   while (*txt1)
    UART1_Write(*(txt1++));
}

void CRLF1()
{
  UART1_Write(CR);
  UART1_Write(LF);
}

 void RAZ_UART1()
{
      RC1IE_bit=0 ;
      for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
      i1=0;
      Index1=0;
      c1=RCREG1;
      c1=0;
      UART1_DataReady=0;
      RC1IE_bit=1 ;
}

void Init_Hardware()
{
  PORTA = 0b00000011;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00000011 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  PORTA=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1

  ANSELE=0;
  TRISE=0;
  PORTE=0xFF;

  PORTD = 0;  // pour LCD
  TRISD=0 ;
  ANSELD  = 0;       // Configure AN pins as digital I/O
  HLVDCON.HLVDEN=0;
  }


 void Beeper(char s)
 {
  switch(s)
  {
     case 1:
       //freq_in_hz: signal frequency in Hertz (Hz)
       // duration_ms: signal duration in miliseconds (ms)
       // Play sound of 1KHz in duration of 100ms
       Sound_Play(1000, 550);
       Sound_Play(1500, 300);
       Sound_Play(500, 500);
       Delay_ms(1000);
       break;
     case 2:
       // Play sound of 1KHz in duration of 100ms
       Sound_Play(500, 550);
       Sound_Play(800, 300);
       Sound_Play(900, 500);
       Delay_ms(1000);
       break;
  default:
    break;
   }
  
  }
  



void main()
{

  #ifdef OSCILLATEUR_INTERNE

    // 16MHz
  //OSCCON.IRCF2=1;
  //OSCCON.IRCF1=1;
  //OSCCON.IRCF0=1;

  //8Mhz
 OSCCON.IRCF2=1;
 OSCCON.IRCF1=1;
  OSCCON.IRCF0=0;
  
  OSCCON.SCS1=1;  // internal oscillator block
  OSCCON.SCS0=0;
  #ifndef DEBUGGING
  while(OSCCON.HFIOFS==0);
  #endif
  #endif

  Init_Hardware();

  
 
   LedA=0;

   txt=&TEXTE[0];

  UART1_Init(19200);
  Delay_ms(100);
  while (UART1_Tx_Idle() == 1) UART1_Write(13);     // vide le buffer
  UART1_Write(CLS);    // efface l'ecran
  #ifndef DEBUGGING
   Delay_ms(1000);       // necessaire pour effacer l'ecran
  #endif
  CRLF1();
  UART1_Write_CText(" Init UART1 19200,8,N,1\r\n");
  UART1_Write_CText(" Mikroc Pro 7.20\r\n");
  UART1_Write_CText(" Source :"Source"_" Version".c\r\n");
  UART1_Write_CText(" PIC 18F46K22 MCU Dip40\r\n");
  UART1_Write_CText(" LCD 2x16 sur bus I2C1 \r\n");
  UART1_Write_CText(" UART1 via USB -> COM4 19200,8,N,1 TerTerm Terminal\r\n");
  UART1_Write_CText(" Test LCD 1602 2x16 en I2C via PCF8754 additionnel\r\n\r\n");
  
  /*
   _______________  TEST ZONE ________________________________
   CRLF1();
  c1=~0x04;
  //c1=~c1;
  ByteToStr(c1,CRam1);
  UART1_Write_Text(CRam1);
  UART1_Write(TAB);
  ByteToHex(c1,CRam1);
   UART1_Write_Text(CRam1);
  CRLF1();
   ___________________________________________________
  
  */
  
  #ifdef TEST_FOSC
  Freq = Clock_kHz();
  UART1_Write_CText(" Fosc =");
  LongWordToStr(Freq, txt) ;
  UART1_Write_Text(txt);
  UART1_Write_CText(" KHz\r\n");
  UART1_Write_CText(" Check delay de 5000mS entre # et @\r\n");
  UART1_Write('#');  CRLF1();
  #ifndef DEBUGGING
  Delay_ms(5000);
  #endif
  UART1_Write('@');  CRLF1();
  #endif


  UART1_Write_CText(" Init I2C1 100Khz\r\n");
  I2C1_Init(100000); // Initialisation de l'I2C
  Delay_ms(500);


  


  i=0x30;
  while(i<128)
  {

   if (check_device(i)==1) break ;
   Delay_ms(50);
   i=i+2;
   }
   Delay_ms(100);
  
  // PCF8574 on pigboard YwRobot back located  on Big LCD 4x20   LCD_ADR=0x4E=78;
  // @ maxi=0x40 + les  3 strap adresse ouverts   = 111+0 => 0x4E
  // LCD_ADR=0x4E;   //   base gros LCD4x20  + PCF8754= 0x4E

  //   base LCD1602  2x16 + PCF8754= 0x40 + 3bits adresse  =0x4A= 74
   LCD_ADR=0x4A;
   addr=LCD_ADR;
   UART1_Write_CText(" Init Display LCD 2x16 : ");
   LCD_init_2x16();
   CRLF1();
   LCD_putch(LCD_CLEAR);
   Delay_ms(300);
   
     UART1_Write_CText(" Ecrit. sur 1ere ligne du LCD : ");
     strConstRamCpy(txt,"Hello I am alive");
     UART1_Write_Text(txt);
     CRLF1();
     Erase_Line(1);
     LCD_Write_CText("Hello I am alive") ;
    
     UART1_Write_CText(" Ecrit. sur 2em ligne du LCD : ");
     strConstRamCpy(txt,"paulfjujo 0123456789");
     UART1_Write_Text(txt);
     CRLF1();
     Erase_Line(2);
     LCD_Write_CText("paulfjujo.free.f") ;

   Delay_ms(5000);
   LCD_putcmd(LCD_CLEAR,1);
   Delay_ms(300);
   Erase_Line(1);
    LCD_Write_CText("Compteur J=      ") ;


  // gestion des interruptions
  RCSTA1.SPEN = 1;
  RCSTA1.RCEN=1;
  RCSTA1.ADDEN=0;
  RCON.IPEN=1   ;  // enable priority levels
  PEIE_bit = 1;   // Enable peripheral interrupts
  GIE_bit  = 1;   // Enable global interrupts
  RAZ_UART1();    //RAZ buffer1 et arme RX1 Interrupt

   Sound_Init(&PORTA,3);
 
   j=0;

  do
 {
   if( UART1_DataReady==1)
   {
     UART1_Write_Text(buffer1);
     CRLF1();

     // to Do here ...
       *(buffer1+32)=0;
       k=strlen(buffer1);
       //Erase_Line(2);
       Erase_Line(1);
       for (i=0;i<k ;i++)
       { 
         *(CRam1+i%16)=*(buffer1+i);
         l=(i/16) ;
         if ((i%16)==0)
         {
           LCD_putcmd(Ligne[l],1);
           strncpy(CRam1,buffer1+i,16);
            LCD_puts(CRam1);
          }
        }
       Delay_ms(6000);
         LCD_putcmd(LCD_CLEAR,1);
           LCD_Write_CText("Compteur J=     ") ;
         CRam1[0]=0;
        UART1_DataReady=0;
        buffer1[i1]=0;
        Index1=i1;
        i1=0;
        c1=0;
        RC1IE_bit=1 ;

     }
    Delay_ms(1000);
    UART1_Write_CText( "J= ");
  //  Erase_Line(1);
    WordToStr(j,CRam1);
    UART1_Write_Text(CRam1);
    CRLF1();

    LCD_putcmd(LCD_LINE1+11,1);
    LCD_puts(CRam1);
     j++;
  } while(1)   ;

 }
 
 /*


*/